#include "stm32f7xx.h"
#include "i2c.h"

int i=0;
void i2c_init(uint32_t timing)
	{
	#define AF4 0x04
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOBEN;
	GPIOB->MODER|=GPIO_MODER_MODER8_1|GPIO_MODER_MODER9_1;
	GPIOB->MODER&=~(GPIO_MODER_MODER8_0|GPIO_MODER_MODER9_0);
	GPIOB->OTYPER|=GPIO_OTYPER_OT8|GPIO_OTYPER_OT9;
	GPIOB->AFR[1]|=(AF4<<0)|(AF4<<4);

	RCC->APB1ENR|=RCC_APB1ENR_I2C1EN;
	I2C1->CR1 &=~I2C_CR1_PE;
	I2C1->TIMINGR=timing;
	I2C1->CR1 |=I2C_CR1_PE;
	}

void i2_read(uint8_t slav_add, uint8_t memadd, uint8_t *data, uint8_t length )
	{
	I2C1->CR1 |=I2C_CR1_PE;
	I2C1->CR2=0;
	I2C1->CR2=(slav_add<<1);
	I2C1->CR2&=~I2C_CR2_ADD10;
	I2C1->CR2|=(1<<I2C_CR2_NBYTES_Pos);
	I2C1->CR2&=~I2C_CR2_RD_WRN;
	I2C1->CR2&=~I2C_CR2_AUTOEND;
	I2C1->CR2|=I2C_CR2_START;
	while(!(I2C1->ISR & I2C_ISR_TC)){
		if(I2C1->ISR & I2C_ISR_TXE)
		{
			I2C1->TXDR = (memadd);
		}
	}
	I2C1->CR1 &=~I2C_CR1_PE;
	I2C1->CR1 |=I2C_CR1_PE;
	I2C1->CR2=0;
	I2C1->CR2=(slav_add<<1);
	I2C1->CR2|=I2C_CR2_RD_WRN;
	I2C1->CR2|=((length)<<I2C_CR2_NBYTES_Pos);
	I2C1->CR2|=I2C_CR2_AUTOEND;
	I2C1->CR2|=I2C_CR2_START;
	i=0;
	while(!(I2C1->ISR & I2C_ISR_STOPF))
			{
			  if(I2C1->ISR &(I2C_ISR_RXNE))
			  	  {
				  *data++=I2C1->RXDR;
				 }
			}
	I2C1->CR1 &=~I2C_CR1_PE;
	}
